diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index bf45585fa..03df1d9c5 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -128,7 +128,7 @@ public class GameSettings {
 	public OptionEnum<RenderScale> renderScale = new OptionEnum<>(this, "renderScale", RenderScale.class, RenderScale.SCALE_100);
 	public OptionBoolean heatHaze = new OptionBoolean(this, "heatHaze", false);
 	public OptionBoolean alphaMenu = new OptionBoolean(this, "old", false);
-	public OptionBoolean enableItemClumping = new OptionBoolean(this, "enableItemClumping", false);
+	public OptionBoolean enableItemClumping = new OptionBoolean(this, "enableItemClumping", true);
 	public OptionBoolean alwaysShowDescriptions = new OptionBoolean(this, "alwaysShowDescriptions", false);
 	public OptionBoolean turnWithVehicle = new OptionBoolean(this, "turnWithVehicle", true);
 	public OptionBoolean disableCrashHandler = new OptionBoolean(this, "disableCrashHandler", false);
@@ -157,6 +157,9 @@ public class GameSettings {
 	public OptionRange mipmapLevels = new OptionRange(this, "mipmapLevels", 0, 5);
 	public OptionEnum<MipmapType> mipmapType = new OptionEnum<>(this, "mipmapType", MipmapType.class, MipmapType.SMOOTH);
 
+	public OptionBoolean fovModification = new OptionBoolean(this, "fov.modification", true);
+	public OptionBoolean screenMotionEffects = new OptionBoolean(this, "screen.motion.effects", true);
+
 	public OptionBoolean fullscreen = new OptionBoolean(this, "fullscreen", Minecraft.isClientASteamDeck());
 	public OptionBoolean borderlessFullscreen = new OptionBoolean(this, "borderlessFullscreen", true);
 	public OptionBoolean startInFullscreen = new OptionBoolean(this, "startInFullscreen", true);
@@ -174,7 +177,14 @@ public class GameSettings {
 	public OptionBoolean enableHolidayTextures = new OptionBoolean(this, "enableHolidayTextures", true);
 	public OptionBoolean dynamicCursor = new OptionBoolean(this, "dynamicCursor", true);
 
-	public OptionBoolean playerLeftHanded = new OptionBoolean(this, "playerLeftHanded", false);
+	public OptionBoolean playerLeftHanded = new OptionBoolean(this, "player.left.handed", false);
+	public OptionBoolean playerCape = new OptionBoolean(this, "player.cape", true);
+	public OptionBoolean playerHat = new OptionBoolean(this, "player.hat", true);
+	public OptionBoolean playerJacket = new OptionBoolean(this, "player.jacket", true);
+	public OptionBoolean playerSleeveLeft = new OptionBoolean(this, "player.sleeve.left", true);
+	public OptionBoolean playerSleeveRight = new OptionBoolean(this, "player.sleeve.right", true);
+	public OptionBoolean playerPantLeft = new OptionBoolean(this, "player.pant.left", true);
+	public OptionBoolean playerPantRight = new OptionBoolean(this, "player.pant.right", true);
 
 	public KeyBinding keyAttack = new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0);
 	public KeyBinding keyInteract = new KeyBinding("key.interact").setDefault(InputDevice.mouse, 1);
@@ -427,9 +437,16 @@ public class GameSettings {
 				mc.currentWorld.setDifficulty(difficulty.value, false);
 			}
 		}
-		if(option == playerLeftHanded && mc.thePlayer != null) {
-			mc.thePlayer.playerConfig.setLeftHand(playerLeftHanded.value);
-		}
+
+		if(option == playerLeftHanded && mc.thePlayer != null) {mc.thePlayer.playerConfig.setLeftHand(playerLeftHanded.value);}
+		if(option == playerCape && mc.thePlayer != null) {mc.thePlayer.playerConfig.setCape(playerCape.value);}
+		if(option == playerHat && mc.thePlayer != null) {mc.thePlayer.playerConfig.setHat(playerHat.value);}
+		if(option == playerJacket && mc.thePlayer != null) {mc.thePlayer.playerConfig.setJacket(playerJacket.value);}
+		if(option == playerSleeveLeft && mc.thePlayer != null) {mc.thePlayer.playerConfig.setSleeveLeft(playerSleeveLeft.value);}
+		if(option == playerSleeveRight && mc.thePlayer != null) {mc.thePlayer.playerConfig.setSleeveRight(playerSleeveRight.value);}
+		if(option == playerPantLeft && mc.thePlayer != null) {mc.thePlayer.playerConfig.setPantLeft(playerPantLeft.value);}
+		if(option == playerPantRight && mc.thePlayer != null) {mc.thePlayer.playerConfig.setPantRight(playerPantRight.value);}
+
 		if(option == enableVsync) mc.gameWindow.setVsync(enableVsync.value);
 		if(option == fancyGraphics) mc.renderGlobal.loadRenderers();
 		if(option == ambientOcclusion) mc.renderGlobal.loadRenderers();
@@ -443,6 +460,7 @@ public class GameSettings {
 		if(option == animations || option == customAnimations) {
 			mc.textureManager.refreshTexturesAndDisplayErrors();
 			mc.textureManager.updateDynamicTextures(false);
+			mc.renderGlobal.loadRenderers();
 		}
 		if(option == fullscreen) mc.gameWindow.updateWindowState();
 		if(option == borderlessFullscreen && fullscreen.value) mc.gameWindow.updateWindowState();
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 3f8597e1d..20ed62e9a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -7,6 +7,7 @@ import static org.lwjgl.opengl.GL12.*;
 import java.awt.image.BufferedImage;
 import java.nio.ByteBuffer;
 import java.util.ArrayList;
+import java.util.Collection;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
@@ -47,6 +48,7 @@ import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.Buffer;
+import net.minecraft.core.util.helper.DyeColor;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
@@ -54,6 +56,11 @@ import org.slf4j.Logger;
 
 public class TextureManager {
 	private static final Logger LOGGER = LogUtils.getLogger();
+
+	public static final int ANIMATIONS_DISABLED = 0;
+	public static final int ANIMATIONS_NATIVE = 1;
+	public static final int ANIMATIONS_CUSTOM = 2;
+
 	public final Minecraft mc;
 
 	public final Map<Integer, Texture> idToTextureMap = new HashMap<>();
@@ -68,7 +75,7 @@ public class TextureManager {
 	private boolean clampTexture;
 	private boolean blurTexture;
 
-	public TextureManager(Minecraft minecraft, TexturePackList texturePacks, GameSettings gameSettings) {
+	public TextureManager(final Minecraft minecraft, final TexturePackList texturePacks, final GameSettings gameSettings) {
 		this.mc = minecraft;
 		
 		this.clampTexture = false;
@@ -78,35 +85,16 @@ public class TextureManager {
 		this.gameSettings = gameSettings;
 	}
 	
-	public void initDynamicTextures(List<Throwable> errors) {
+	public void initDynamicTextures(final Collection<? super Throwable> errors) {
 		LOGGER.info("Initializing Dynamic Textures...");
 
-		dynamicTextures.clear();
-
-		if (mc.gameSettings.animations.value != 0) {
-			boolean useCustomAnimations = mc.gameSettings.animations.value == 2;
+        this.dynamicTextures.clear();
 
+		addNativeDynamicTextures(this.mc.gameSettings.animations.value);
+		if (this.mc.gameSettings.customAnimations.value && this.mc.gameSettings.animations.value == ANIMATIONS_CUSTOM) {
 			try {
-                addDynamicTexture(new DynamicTextureWaterStill(TextureRegistry.getTexture("minecraft:block/water_still")));
-                addDynamicTexture(new DynamicTextureWaterFlow(TextureRegistry.getTexture("minecraft:block/water_flowing")));
-                addDynamicTexture(new DynamicTextureLavaStill(TextureRegistry.getTexture("minecraft:block/lava_still")));
-                addDynamicTexture(new DynamicTextureLavaFlowing(TextureRegistry.getTexture("minecraft:block/lava_flowing")));
-//                addDynamicTexture(new DynamicTexturePortal(TextureRegistry.getTexture("minecraft:block/portal_nether"),false));
-                addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire"), false));
-				addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire_cold"), true));
-
-                String[] fireflycolors = new String[] {"blue", "orange", "green", "red"};
-				for (String color : fireflycolors) {
-					addDynamicTexture(new DynamicTextureFireflyJar(TextureRegistry.getTexture("minecraft:block/lantern_firefly/" + color)));
-				}
-
-				addDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel/active_front"), true));
-				addDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel/active_back"), false));
-
-				if (useCustomAnimations) {
-					loadCustomAnimations();
-				}
-			}catch (TexturePackException e) {
+				loadCustomAnimations();
+			}catch (final TexturePackException e) {
 				errors.add(e);
 			}
 		}
@@ -116,6 +104,35 @@ public class TextureManager {
 		addDynamicTextureOverride(new DynamicTextureCompass(mc, TextureRegistry.getTexture("minecraft:item/tool_compass")), true);
 	}
 
+	protected void addNativeDynamicTextures(int state) {
+		if (state > ANIMATIONS_DISABLED) {addDynamicTexture(new DynamicTextureWaterStill(TextureRegistry.getTexture("minecraft:block/water_still")));
+			addDynamicTexture(new DynamicTextureWaterFlow(TextureRegistry.getTexture("minecraft:block/water_flowing")));
+			addDynamicTexture(new DynamicTextureLavaStill(TextureRegistry.getTexture("minecraft:block/lava_still")));
+			addDynamicTexture(new DynamicTextureLavaFlowing(TextureRegistry.getTexture("minecraft:block/lava_flowing")));
+            addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire"), false));
+            addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire_cold"), true));
+
+			final String[] fireflyColors = {"blue", "orange", "green", "red"};
+			for (final String color : fireflyColors) {
+				addDynamicTexture(new DynamicTextureFireflyJar(TextureRegistry.getTexture("minecraft:block/lantern_firefly/" + color)));
+			}
+
+			addDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel/active_front"), true));
+			addDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel/active_back"), false));
+		}
+		if (state < ANIMATIONS_CUSTOM) {
+			for (final DyeColor c : DyeColor.values()) {
+				final IconCoordinate cNether = TextureRegistry.getTexture("minecraft:block/portal_nether/" + c.colorID);
+				assert cNether.hasMeta("animation") : "Coordinate " + cNether.namespaceId + " is expected to have animation data attached!";
+				addDynamicTexture(new DynamicTextureCustom(cNether, cNether.getMeta("animation", AnimationProperties.class)));
+
+				final IconCoordinate cParadise = TextureRegistry.getTexture("minecraft:block/portal_paradise/" + c.colorID);
+				assert cParadise.hasMeta("animation") : "Coordinate " + cParadise.namespaceId + " is expected to have animation data attached!";
+				addDynamicTexture(new DynamicTextureCustom(cParadise, cParadise.getMeta("animation", AnimationProperties.class)));
+			}
+		}
+	}
+
 	protected void addDynamicTexture(DynamicTexture texture) {
 		addDynamicTextureOverride(texture, false);
 	}
@@ -125,12 +142,12 @@ public class TextureManager {
 	}
 
 	private void loadCustomAnimations() {
-		if(!mc.gameSettings.customAnimations.value) {
+		if(!this.mc.gameSettings.customAnimations.value) {
 			return;
 		}
 
-		for (AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
-			for (IconCoordinate c : stitcher.textureMap.values()) {
+		for (final AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
+			for (final IconCoordinate c : stitcher.textureMap.values()) {
 				if (c.hasMeta("animation")) {
                     LOGGER.debug("Icon '{}' has 'animation' meta!", c.namespaceId);
 					addDynamicTextureOverride(new DynamicTextureCustom(c, c.getMeta("animation", AnimationProperties.class)), true);
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index fa03f360a..a9ece6d4d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -115,7 +115,7 @@ public class WorldRenderer
     private void updateSpeedFov()
     {
         PlayerLocal player = mc.thePlayer;
-        currentFovModifier = player.getFovModifier();
+        currentFovModifier = mc.gameSettings.fovModification.value ? player.getFovModifier() : 1f;
         a = b;
         b += (currentFovModifier - b) * 0.5f;
     }
@@ -316,44 +316,44 @@ public class WorldRenderer
         }
     }
 
-    private void setupCameraTransform(float partialTick)
+    private void setupCameraTransform(final float partialTicks)
     {
-        farPlaneDistance = mc.gameSettings.renderDistance.value * 16;
+        this.farPlaneDistance = this.mc.gameSettings.renderDistance.value * 16;
         glMatrixMode(GL_PROJECTION);
         glLoadIdentity();
-        float fov = getFOVModifier(partialTick, true);
-        if(zooming) {
-            fov = getZoomedFOV(fov, partialTick);
+        float fov = getFOVModifier(partialTicks, true);
+        if(this.zooming) {
+            fov = getZoomedFOV(fov, partialTicks);
         } else {
-            zoomProgress = 0;
+            this.zoomProgress = 0;
         }
-        if (mc.currentScreen instanceof ScreenPhotoMode)
+        if (this.mc.currentScreen instanceof ScreenPhotoMode)
         {
-            double div = java.lang.Math.pow(2, ((ScreenPhotoMode)mc.currentScreen).getZoom(partialTick));
+            final double div = java.lang.Math.pow(2, ((ScreenPhotoMode) this.mc.currentScreen).getZoom(partialTicks));
             glTranslatef(1, 1, 0);
-            glOrtho(0, mc.gameWindow.getWidthPixels() / div, 0, mc.gameWindow.getHeightPixels() / div, farPlaneDistance * -2.0f, farPlaneDistance * 2.0f);
-            glTranslatef(((ScreenPhotoMode)mc.currentScreen).getPanX(partialTick), -((ScreenPhotoMode)mc.currentScreen).getPanY(partialTick), 0);
+            glOrtho(0, this.mc.gameWindow.getWidthPixels() / div, 0, this.mc.gameWindow.getHeightPixels() / div, this.farPlaneDistance * -2.0f, this.farPlaneDistance * 2.0f);
+            glTranslatef(((ScreenPhotoMode) this.mc.currentScreen).getPanX(partialTicks), -((ScreenPhotoMode) this.mc.currentScreen).getPanY(partialTicks), 0);
         } else
         {
-            GLU.gluPerspective(fov, (float)mc.gameWindow.getWidthPixels() / (float)mc.gameWindow.getHeightPixels(), 0.05F, farPlaneDistance * 2.0F);
+            GLU.gluPerspective(fov, (float) this.mc.gameWindow.getWidthPixels() / (float) this.mc.gameWindow.getHeightPixels(), 0.05F, this.farPlaneDistance * 2.0F);
         }
         glMatrixMode(GL_MODELVIEW);
         glLoadIdentity();
-        hurtCameraEffect(partialTick);
-        if(mc.gameSettings.viewBobbing.value && !(mc.currentScreen instanceof ScreenPhotoMode))
+        hurtCameraEffect(partialTicks);
+        if(this.mc.gameSettings.viewBobbing.value && !(this.mc.currentScreen instanceof ScreenPhotoMode))
         {
-            setupViewBobbing(partialTick);
+            setupViewBobbing(partialTicks);
         }
-        float f2 = mc.thePlayer.prevTimeInPortal + (mc.thePlayer.timeInPortal - mc.thePlayer.prevTimeInPortal) * partialTick;
-        if(f2 > 0.0F)
+        final float portalIntensity = this.mc.gameSettings.screenMotionEffects.value ? MathHelper.lerp(this.mc.thePlayer.prevTimeInPortal, this.mc.thePlayer.timeInPortal, partialTicks) : 0f;
+        if(portalIntensity > 0.0F)
         {
-            float f3 = 5F / (f2 * f2 + 5F) - f2 * 0.04F;
+            float f3 = 5F / (portalIntensity * portalIntensity + 5F) - portalIntensity * 0.04F;
             f3 *= f3;
-            glRotatef(((float)rendererUpdateCount + partialTick) * 20F, 0.0F, 1.0F, 1.0F);
+            glRotatef(((float) this.rendererUpdateCount + partialTicks) * 20F, 0.0F, 1.0F, 1.0F);
             glScalef(1.0F / f3, 1.0F, 1.0F);
-            glRotatef(-((float)rendererUpdateCount + partialTick) * 20F, 0.0F, 1.0F, 1.0F);
+            glRotatef(-((float) this.rendererUpdateCount + partialTicks) * 20F, 0.0F, 1.0F, 1.0F);
         }
-        orientCamera(partialTick);
+        orientCamera(partialTicks);
     }
 
     private void renderHand(float partialTick)
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
index db740a5af..89295e750 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
@@ -186,6 +186,6 @@ public class DynamicTextureCustom extends DynamicTexture {
 	}
 	@Override
 	public boolean runUpdates(boolean isPaused) {
-		return (!isPaused || tickWhenPaused);
+		return mc.gameSettings.animations.value != 0 && (!isPaused || tickWhenPaused);
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 72f55827f..5ef2d7207 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -202,39 +202,41 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
 
         super.renderAdditional(player, partialTick);
 
-        boolean renderCape = bindDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + player.username, null, null);
-        if (!renderCape)
-        {
-            renderCape = bindDownloadableTexture(player.capeURL, null, null);
-        }
-
-        if(renderCape) {
-            GL11.glPushMatrix();
-            float brightness = (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) ? 1 : player.getBrightness(partialTick);
-            GL11.glColor4f(brightness, brightness, brightness, 1f);
-            GL11.glTranslatef(0.0F, 0.0F, 0.125F);
-            float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
-            float bodyAngle = 5;
-            if(player.isSneaking())
+        if (player.playerConfig.capeEnabled()) {
+            boolean renderCape = bindDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + player.username, null, null);
+            if (!renderCape)
             {
-                bodyAngle += 25F;
+                renderCape = bindDownloadableTexture(player.capeURL, null, null);
+            }
+
+            if(renderCape) {
+                GL11.glPushMatrix();
+                float brightness = (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) ? 1 : player.getBrightness(partialTick);
+                GL11.glColor4f(brightness, brightness, brightness, 1f);
+                GL11.glTranslatef(0.0F, 0.0F, 0.125F);
+                float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
+                float bodyAngle = 5;
+                if(player.isSneaking())
+                {
+                    bodyAngle += 25F;
+                }
+                double _xd = player.xdO + (player.xd - player.xdO) * partialTick;
+                double _yd = Math.min(player.ydO + (player.yd - player.ydO) * partialTick, 0);
+                double _zd = player.zd0 + (player.zd - player.zd0) * partialTick;
+                double vel = -1/(3 * Math.hypot(_xd, _zd) + 1) + 1;
+                double moveAng = Math.atan2(_xd, _zd);
+                double yawRad = Math.toRadians(yawOff);
+                double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2)/2) -1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
+                player.wobbleTimer += (float) (((player.tickCount + partialTick) - player.lastRenderTick)/(30 - 29 * MathHelper.clamp(vel, 0, 1)));
+                player.lastRenderTick = player.tickCount;
+                double wobble = Math.sin(player.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
+                GL11.glRotatef((float) MathHelper.clamp((MathHelper.clamp(bodyAngle + vel * 100 * multiplier, bodyAngle, 100f) + wobble) - _yd * 60, 0, 180), 1.0F, 0.0F, 0.0F);
+                GL11.glRotatef(0, 0.0F, 0.0F, 1.0F);
+                GL11.glRotatef(0, 0.0F, 1.0F, 0.0F);
+                GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
+                modelBipedMain.renderCloak(0.0625F);
+                GL11.glPopMatrix();
             }
-            double _xd = player.xdO + (player.xd - player.xdO) * partialTick;
-            double _yd = Math.min(player.ydO + (player.yd - player.ydO) * partialTick, 0);
-            double _zd = player.zd0 + (player.zd - player.zd0) * partialTick;
-            double vel = -1/(3 * Math.hypot(_xd, _zd) + 1) + 1;
-            double moveAng = Math.atan2(_xd, _zd);
-            double yawRad = Math.toRadians(yawOff);
-            double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2)/2) -1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
-            player.wobbleTimer += (float) (((player.tickCount + partialTick) - player.lastRenderTick)/(30 - 29 * MathHelper.clamp(vel, 0, 1)));
-            player.lastRenderTick = player.tickCount;
-            double wobble = Math.sin(player.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
-            GL11.glRotatef((float) MathHelper.clamp((MathHelper.clamp(bodyAngle + vel * 100 * multiplier, bodyAngle, 100f) + wobble) - _yd * 60, 0, 180), 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(0, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(0, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
-            modelBipedMain.renderCloak(0.0625F);
-            GL11.glPopMatrix();
         }
 
         if (player.getHeldObject() != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelPlayer.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelPlayer.java
index 4a8a0aa1b..70903946e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelPlayer.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.model;
 
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -64,14 +65,34 @@ public class ModelPlayer extends ModelBiped {
 
     @Override
 	public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick){
-        super.render(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
-        GL11.glPushMatrix();
-        bipedLeftArmOverlay.render(scale);
-        bipedRightArmOverlay.render(scale);
-        bipedLeftLegOverlay.render(scale);
-        bipedRightLegOverlay.render(scale);
-        bipedBodyOverlay.render(scale);
-        GL11.glPopMatrix();
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
+        head.render(scale);
+        body.render(scale);
+        armRight.render(scale);
+        armLeft.render(scale);
+        legRight.render(scale);
+        legLeft.render(scale);
+        if (mob instanceof Player) {
+            Player player = (Player) mob;
+            if (player.playerConfig.hatEnabled()) hair.render(scale);
+            GL11.glPushMatrix();
+            if (player.playerConfig.sleeveLeftEnabled()) bipedLeftArmOverlay.render(scale);
+            if (player.playerConfig.sleeveRightEnabled()) bipedRightArmOverlay.render(scale);
+            if (player.playerConfig.pantLeftEnabled()) bipedLeftLegOverlay.render(scale);
+            if (player.playerConfig.pantRightEnabled()) bipedRightLegOverlay.render(scale);
+            if (player.playerConfig.jacketEnabled()) bipedBodyOverlay.render(scale);
+            GL11.glPopMatrix();
+        } else {
+            hair.render(scale);
+            GL11.glPushMatrix();
+            bipedLeftArmOverlay.render(scale);
+            bipedRightArmOverlay.render(scale);
+            bipedLeftLegOverlay.render(scale);
+            bipedRightLegOverlay.render(scale);
+            bipedBodyOverlay.render(scale);
+            GL11.glPopMatrix();
+        }
+
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
index 14ef09aa1..1d9ab4b49 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
@@ -48,7 +48,7 @@ public abstract class TexturePack {
 	{
 		if (Holidays.getCurrentThemedHoliday() != null && Minecraft.getMinecraft().gameSettings.enableHolidayTextures.value) {
 			assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
-			String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + s);
+			String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + s).replace("//", "/");
 			InputStream holidayStream = TexturePack.class.getResourceAsStream(holidayPath);
 			if (holidayStream != null) return holidayStream;
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
index 622bd99e6..276f0eb0c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
@@ -192,7 +192,7 @@ public class TexturePackCustom extends TexturePack
 	{
 		if (firstCall && Holidays.getCurrentThemedHoliday() != null && Minecraft.getMinecraft().gameSettings.enableHolidayTextures.value) {
 			assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
-			String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + path);
+			String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + path).replace("//", "/");
 			InputStream holidayStream = getResourceAsStream(holidayPath, false);
 			if (holidayStream != null) return holidayStream;
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
index dd90eff40..a02869ba9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
@@ -69,7 +69,7 @@ public class TexturePackDefault extends TexturePack
                 return true;
             } else if (Minecraft.getMinecraft().gameSettings.enableHolidayTextures.value && Holidays.getCurrentThemedHoliday() != null) {
                 assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
-                String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + file);
+                String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + file).replace("//", "/");
                 InputStream holidayStream = TexturePack.class.getResourceAsStream(holidayPath);
                 if (holidayStream != null) {
                     holidayStream.close();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
index 22d4b469a..1772a1c40 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
@@ -48,7 +48,7 @@ public class BlockLogicFlag extends BlockLogic {
         if (tileEntity != null)
         {
             CompoundTag compound = new CompoundTag();
-            ((TileEntityFlag) tileEntity).writeFlagNBT(compound);
+            tileEntity.writeAdditionalData(compound);
             stack.getData().putCompound("FlagData", compound);
         }
         return new ItemStack[] { stack };
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
index 9fd501014..3a7bb6031 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
@@ -4,6 +4,7 @@ import java.util.Random;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureCherryTreeFancy;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCherry;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 
@@ -18,7 +19,7 @@ public class BlockLogicSaplingCherry extends BlockLogicSaplingBase
     @Override
 	public void growTree(World world, int x, int y, int z, Random random)
     {
-        WorldFeature treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id());
+        WorldFeature treeBig  = new WorldFeatureCherryTreeFancy(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id());
         WorldFeature treeSmall = new WorldFeatureTreeCherry(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id(), 4);
         world.setBlock(x, y, z, 0);
 
